View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.transport.udp;
    21
    22  import java.net.SocketAddress;
    23
    24  import org.apache.mina.api.IoFuture;
    25  import org.apache.mina.api.IoSession;
    26  import org.apache.mina.service.client.AbstractIoClient;
    27  import org.apache.mina.service.executor.IoHandlerExecutor;
    28
    29  /**
    30   * Base class for UDP based Clients
    31   *
    32   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    33   */
    34  public abstract class AbstractUdpClient extends AbstractIoClient {
    35      /**
    36       * Create an new AbsractUdpClient instance
    37       */
    38      protected AbstractUdpClient(IoHandlerExecutor ioHandlerExecutor) {
    39          super(ioHandlerExecutor);
    40          this.config = new DefaultUdpSessionConfig();
    41      }
    42
    43      /**
    44       * Connects to the specified remote address binding to the specified local address.
    45       *
    46       * @param remoteAddress Remote {@link SocketAddress} to connect
    47       * @param localAddress Local {@link SocketAddress} to use while initiating connection to remote
    48       *        {@link SocketAddress}
    49       * @return the {@link IoFuture} instance which is completed when the connection attempt initiated by this call
    50       *         succeeds or fails.
    51       */
    52      public abstract IoFuture<IoSession> connect(SocketAddress remoteAddress, SocketAddress localAddress);
    53
    54      /**
    55       * {@inheritDoc}
    56       */
    57      @Override
    58      public UdpSessionConfig getSessionConfig() {
    59          return (UdpSessionConfig) config;
    60      }
    61  }